<?php

namespace Drupal\vgwort\Plugin\vgwort\ParticipantList;

use Drupal\Core\Entity\EntityInterface;
use Drupal\user\EntityOwnerInterface;
use Drupal\user\UserInterface;
use Drupal\vgwort\FieldParticipantListBase;

/**
 * @ParticipantList(
 *   id = "entity_owner_field",
 *   admin_label = @Translation("Entity owner field")
 * )
 */
class EntityOwnerField extends FieldParticipantListBase {

  /**
   * {@inheritdoc}
   */
  public function getParticipants(EntityInterface $entity): array {
    if ($entity instanceof EntityOwnerInterface) {
      return $this->doGetParticipants($entity->getOwner());
    }
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function isApplicable(EntityInterface $entity): bool {
    if ($entity instanceof EntityOwnerInterface) {
      $owner = $entity->getOwner();
      if ($owner instanceof UserInterface) {
        $entity_type = $entity->getOwner()->getEntityTypeId();
        $bundle = $entity->getOwner()->bundle() ?: $entity_type;
        return !empty($this->getParticipantFields($entity_type, $bundle));
      }
    }
    return FALSE;
  }

}
