<?php

namespace Drupal\Tests\vgwort\Functional;

use Drupal\FunctionalTests\Update\UpdatePathTestBase;
use Drupal\Tests\system\Functional\Cache\AssertPageCacheContextsAndTagsTrait;

/**
 * Tests the VG Wort module.
 *
 * @group vgwort
 */
class VGWortUpdateTest extends UpdatePathTestBase {
  use AssertPageCacheContextsAndTagsTrait;

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * {@inheritdoc}
   */
  protected function setDatabaseDumpFiles() {
    $this->databaseDumpFiles[] = $this->root . '/core/modules/system/tests/fixtures/update/drupal-9.4.0.bare.standard.php.gz';
    $this->databaseDumpFiles[] = __DIR__ . '/../../fixtures/install_vgwort_for_update_testing.php';
  }

  /**
   * Tests update functions.
   */
  public function testVgWortUpdates(): void {
    // Ensure install_vgwort_for_update_testing.php is working.
    $this->assertTrue(\Drupal::moduleHandler()->moduleExists('vgwort'));
    $this->assertEmpty($this->config('vgwort.settings')->get('entity_types'));
    $this->assertNull($this->config('vgwort.settings')->get('test_mode'));
    $this->assertSame('vgzm', $this->config('vgwort.settings')->get('prefix'));

    // Run updates and test them.
    $this->runUpdates();
    $this->assertContains('node', $this->config('vgwort.settings')->get('entity_types'));
    $this->assertFalse($this->config('vgwort.settings')->get('test_mode'));
  }

}
