<?php

namespace Drupal\Tests\vgwort\Kernel;

use Drupal\field\Entity\FieldConfig;
use Drupal\field\Entity\FieldStorageConfig;
use Drupal\KernelTests\KernelTestBase;
use Drupal\user\Entity\User;

/**
 * Tests the participant plugins and manager.
 *
 * @group vgwort
 */
abstract class ParticipantFieldTestBase extends KernelTestBase {

  /**
   * Modules to enable.
   *
   * @var array
   */
  protected static $modules = ['user', 'field', 'entity_test', 'vgwort'];

  /**
   * {@inheritdoc}
   */
  protected function setUp(): void {
    parent::setUp();

    $this->installEntitySchema('user');
    User::create(['name' => 'User 1', 'status' => TRUE])->save();

    $this->installEntitySchema('entity_test');
    $entity_type = 'entity_test';

    $fieldStorage = FieldStorageConfig::create([
      'field_name' => 'vgwort_test',
      'entity_type' => $entity_type,
      'type' => 'vgwort_participant_info',
      'cardinality' => 4,
    ]);
    $fieldStorage->save();
    $field = FieldConfig::create([
      'field_storage' => $fieldStorage,
      'bundle' => $entity_type,
    ]);
    $field->save();

    $fieldStorage = FieldStorageConfig::create([
      'field_name' => 'vgwort_test2',
      'entity_type' => $entity_type,
      'type' => 'vgwort_participant_info',
      'cardinality' => 1,
    ]);
    $fieldStorage->save();
    $field = FieldConfig::create([
      'field_storage' => $fieldStorage,
      'bundle' => $entity_type,
      'settings' => [
        'involvement' => 'TRANSLATOR',
      ],
    ]);
    $field->save();

    $fieldStorage = FieldStorageConfig::create([
      'field_name' => 'vgwort_test',
      'entity_type' => 'user',
      'type' => 'vgwort_participant_info',
      'cardinality' => 1,
    ]);
    $fieldStorage->save();
    $field = FieldConfig::create([
      'field_storage' => $fieldStorage,
      'bundle' => 'user',
    ]);
    $field->save();
  }

}
